# coding: utf-8

"""
    Overseerr API

    This is the documentation for the Overseerr API backend.  Two primary authentication methods are supported:  - **Cookie Authentication**: A valid sign-in to the `/auth/plex` or `/auth/local` will generate a valid authentication cookie. - **API Key Authentication**: Sign-in is also possible by passing an `X-Api-Key` header along with a valid API Key generated by Overseerr. 

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr

class DiscoverSlider(BaseModel):
    """
    DiscoverSlider
    """
    data: Optional[StrictStr] = Field(...)
    enabled: StrictBool = Field(...)
    id: Optional[Union[StrictFloat, StrictInt]] = None
    is_built_in: Optional[StrictBool] = Field(None, alias="isBuiltIn")
    title: Optional[StrictStr] = Field(...)
    type: Union[StrictFloat, StrictInt] = Field(...)
    __properties = ["data", "enabled", "id", "isBuiltIn", "title", "type"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DiscoverSlider:
        """Create an instance of DiscoverSlider from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if data (nullable) is None
        # and __fields_set__ contains the field
        if self.data is None and "data" in self.__fields_set__:
            _dict['data'] = None

        # set to None if title (nullable) is None
        # and __fields_set__ contains the field
        if self.title is None and "title" in self.__fields_set__:
            _dict['title'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DiscoverSlider:
        """Create an instance of DiscoverSlider from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return DiscoverSlider.parse_obj(obj)

        _obj = DiscoverSlider.parse_obj({
            "data": obj.get("data"),
            "enabled": obj.get("enabled"),
            "id": obj.get("id"),
            "is_built_in": obj.get("isBuiltIn"),
            "title": obj.get("title"),
            "type": obj.get("type")
        })
        return _obj


