# coding: utf-8

"""
    Overseerr API

    This is the documentation for the Overseerr API backend.  Two primary authentication methods are supported:  - **Cookie Authentication**: A valid sign-in to the `/auth/plex` or `/auth/local` will generate a valid authentication cookie. - **API Key Authentication**: Sign-in is also possible by passing an `X-Api-Key` header along with a valid API Key generated by Overseerr. 

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from overseerr_api.models.movie_result import MovieResult
from overseerr_api.models.person_result import PersonResult
from overseerr_api.models.tv_result import TvResult
from typing import Union, Any, List, TYPE_CHECKING
from pydantic import StrictStr, Field

DISCOVERTRENDINGGET200RESPONSERESULTSINNER_ANY_OF_SCHEMAS = ["MovieResult", "PersonResult", "TvResult"]

class DiscoverTrendingGet200ResponseResultsInner(BaseModel):
    """
    DiscoverTrendingGet200ResponseResultsInner
    """

    # data type: MovieResult
    anyof_schema_1_validator: Optional[MovieResult] = None
    # data type: TvResult
    anyof_schema_2_validator: Optional[TvResult] = None
    # data type: PersonResult
    anyof_schema_3_validator: Optional[PersonResult] = None
    if TYPE_CHECKING:
        actual_instance: Union[MovieResult, PersonResult, TvResult]
    else:
        actual_instance: Any
    any_of_schemas: List[str] = Field(DISCOVERTRENDINGGET200RESPONSERESULTSINNER_ANY_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @validator('actual_instance')
    def actual_instance_must_validate_anyof(cls, v):
        instance = DiscoverTrendingGet200ResponseResultsInner.construct()
        error_messages = []
        # validate data type: MovieResult
        if not isinstance(v, MovieResult):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MovieResult`")
        else:
            return v

        # validate data type: TvResult
        if not isinstance(v, TvResult):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TvResult`")
        else:
            return v

        # validate data type: PersonResult
        if not isinstance(v, PersonResult):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PersonResult`")
        else:
            return v

        if error_messages:
            # no match
            raise ValueError("No match found when setting the actual_instance in DiscoverTrendingGet200ResponseResultsInner with anyOf schemas: MovieResult, PersonResult, TvResult. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> DiscoverTrendingGet200ResponseResultsInner:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> DiscoverTrendingGet200ResponseResultsInner:
        """Returns the object represented by the json string"""
        instance = DiscoverTrendingGet200ResponseResultsInner.construct()
        error_messages = []
        # anyof_schema_1_validator: Optional[MovieResult] = None
        try:
            instance.actual_instance = MovieResult.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_2_validator: Optional[TvResult] = None
        try:
            instance.actual_instance = TvResult.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))
        # anyof_schema_3_validator: Optional[PersonResult] = None
        try:
            instance.actual_instance = PersonResult.from_json(json_str)
            return instance
        except (ValidationError, ValueError) as e:
             error_messages.append(str(e))

        if error_messages:
            # no match
            raise ValueError("No match found when deserializing the JSON string into DiscoverTrendingGet200ResponseResultsInner with anyOf schemas: MovieResult, PersonResult, TvResult. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        to_json = getattr(self.actual_instance, "to_json", None)
        if callable(to_json):
            return self.actual_instance.to_dict()
        else:
            return json.dumps(self.actual_instance)

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())


