# coding: utf-8

"""
    Overseerr API

    This is the documentation for the Overseerr API backend.  Two primary authentication methods are supported:  - **Cookie Authentication**: A valid sign-in to the `/auth/plex` or `/auth/local` will generate a valid authentication cookie. - **API Key Authentication**: Sign-in is also possible by passing an `X-Api-Key` header along with a valid API Key generated by Overseerr. 

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, conlist
from overseerr_api.models.user import User

class MediaMediaIdWatchDataGet200ResponseData(BaseModel):
    """
    MediaMediaIdWatchDataGet200ResponseData
    """
    play_count: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="playCount")
    play_count30_days: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="playCount30Days")
    play_count7_days: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="playCount7Days")
    users: Optional[conlist(User)] = None
    __properties = ["playCount", "playCount30Days", "playCount7Days", "users"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> MediaMediaIdWatchDataGet200ResponseData:
        """Create an instance of MediaMediaIdWatchDataGet200ResponseData from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in users (list)
        _items = []
        if self.users:
            for _item in self.users:
                if _item:
                    _items.append(_item.to_dict())
            _dict['users'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> MediaMediaIdWatchDataGet200ResponseData:
        """Create an instance of MediaMediaIdWatchDataGet200ResponseData from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return MediaMediaIdWatchDataGet200ResponseData.parse_obj(obj)

        _obj = MediaMediaIdWatchDataGet200ResponseData.parse_obj({
            "play_count": obj.get("playCount"),
            "play_count30_days": obj.get("playCount30Days"),
            "play_count7_days": obj.get("playCount7Days"),
            "users": [User.from_dict(_item) for _item in obj.get("users")] if obj.get("users") is not None else None
        })
        return _obj


