# coding: utf-8

"""
    Overseerr API

    This is the documentation for the Overseerr API backend.  Two primary authentication methods are supported:  - **Cookie Authentication**: A valid sign-in to the `/auth/plex` or `/auth/local` will generate a valid authentication cookie. - **API Key Authentication**: Sign-in is also possible by passing an `X-Api-Key` header along with a valid API Key generated by Overseerr. 

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from overseerr_api.models.media_request_modified_by import MediaRequestModifiedBy
from overseerr_api.models.user import User

class MediaRequest(BaseModel):
    """
    MediaRequest
    """
    created_at: Optional[StrictStr] = Field(None, alias="createdAt")
    id: Union[StrictFloat, StrictInt] = Field(...)
    is4k: Optional[StrictBool] = None
    media: Optional[MediaInfo] = None
    modified_by: Optional[MediaRequestModifiedBy] = Field(None, alias="modifiedBy")
    profile_id: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="profileId")
    requested_by: Optional[User] = Field(None, alias="requestedBy")
    root_folder: Optional[StrictStr] = Field(None, alias="rootFolder")
    server_id: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="serverId")
    status: Union[StrictFloat, StrictInt] = Field(..., description="Status of the request. 1 = PENDING APPROVAL, 2 = APPROVED, 3 = DECLINED")
    updated_at: Optional[StrictStr] = Field(None, alias="updatedAt")
    __properties = ["createdAt", "id", "is4k", "media", "modifiedBy", "profileId", "requestedBy", "rootFolder", "serverId", "status", "updatedAt"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> MediaRequest:
        """Create an instance of MediaRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "created_at",
                            "id",
                            "status",
                            "updated_at",
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of media
        if self.media:
            _dict['media'] = self.media.to_dict()
        # override the default output from pydantic by calling `to_dict()` of modified_by
        if self.modified_by:
            _dict['modifiedBy'] = self.modified_by.to_dict()
        # override the default output from pydantic by calling `to_dict()` of requested_by
        if self.requested_by:
            _dict['requestedBy'] = self.requested_by.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> MediaRequest:
        """Create an instance of MediaRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return MediaRequest.parse_obj(obj)

        _obj = MediaRequest.parse_obj({
            "created_at": obj.get("createdAt"),
            "id": obj.get("id"),
            "is4k": obj.get("is4k"),
            "media": MediaInfo.from_dict(obj.get("media")) if obj.get("media") is not None else None,
            "modified_by": MediaRequestModifiedBy.from_dict(obj.get("modifiedBy")) if obj.get("modifiedBy") is not None else None,
            "profile_id": obj.get("profileId"),
            "requested_by": User.from_dict(obj.get("requestedBy")) if obj.get("requestedBy") is not None else None,
            "root_folder": obj.get("rootFolder"),
            "server_id": obj.get("serverId"),
            "status": obj.get("status"),
            "updated_at": obj.get("updatedAt")
        })
        return _obj

from overseerr_api.models.media_info import MediaInfo
MediaRequest.update_forward_refs()

