# coding: utf-8

"""
    Overseerr API

    This is the documentation for the Overseerr API backend.  Two primary authentication methods are supported:  - **Cookie Authentication**: A valid sign-in to the `/auth/plex` or `/auth/local` will generate a valid authentication cookie. - **API Key Authentication**: Sign-in is also possible by passing an `X-Api-Key` header along with a valid API Key generated by Overseerr. 

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, StrictStr, conlist
from overseerr_api.models.movie_details_releases_results_inner_release_dates_inner import MovieDetailsReleasesResultsInnerReleaseDatesInner

class MovieDetailsReleasesResultsInner(BaseModel):
    """
    MovieDetailsReleasesResultsInner
    """
    iso_3166_1: Optional[StrictStr] = None
    rating: Optional[StrictStr] = None
    release_dates: Optional[conlist(MovieDetailsReleasesResultsInnerReleaseDatesInner)] = None
    __properties = ["iso_3166_1", "rating", "release_dates"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> MovieDetailsReleasesResultsInner:
        """Create an instance of MovieDetailsReleasesResultsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in release_dates (list)
        _items = []
        if self.release_dates:
            for _item in self.release_dates:
                if _item:
                    _items.append(_item.to_dict())
            _dict['release_dates'] = _items
        # set to None if rating (nullable) is None
        # and __fields_set__ contains the field
        if self.rating is None and "rating" in self.__fields_set__:
            _dict['rating'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> MovieDetailsReleasesResultsInner:
        """Create an instance of MovieDetailsReleasesResultsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return MovieDetailsReleasesResultsInner.parse_obj(obj)

        _obj = MovieDetailsReleasesResultsInner.parse_obj({
            "iso_3166_1": obj.get("iso_3166_1"),
            "rating": obj.get("rating"),
            "release_dates": [MovieDetailsReleasesResultsInnerReleaseDatesInner.from_dict(_item) for _item in obj.get("release_dates")] if obj.get("release_dates") is not None else None
        })
        return _obj


