# coding: utf-8

"""
    Overseerr API

    This is the documentation for the Overseerr API backend.  Two primary authentication methods are supported:  - **Cookie Authentication**: A valid sign-in to the `/auth/plex` or `/auth/local` will generate a valid authentication cookie. - **API Key Authentication**: Sign-in is also possible by passing an `X-Api-Key` header along with a valid API Key generated by Overseerr. 

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, StrictFloat, StrictInt

class NotificationAgentTypes(BaseModel):
    """
    NotificationAgentTypes
    """
    discord: Optional[Union[StrictFloat, StrictInt]] = None
    email: Optional[Union[StrictFloat, StrictInt]] = None
    pushbullet: Optional[Union[StrictFloat, StrictInt]] = None
    pushover: Optional[Union[StrictFloat, StrictInt]] = None
    slack: Optional[Union[StrictFloat, StrictInt]] = None
    telegram: Optional[Union[StrictFloat, StrictInt]] = None
    webhook: Optional[Union[StrictFloat, StrictInt]] = None
    webpush: Optional[Union[StrictFloat, StrictInt]] = None
    __properties = ["discord", "email", "pushbullet", "pushover", "slack", "telegram", "webhook", "webpush"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> NotificationAgentTypes:
        """Create an instance of NotificationAgentTypes from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> NotificationAgentTypes:
        """Create an instance of NotificationAgentTypes from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return NotificationAgentTypes.parse_obj(obj)

        _obj = NotificationAgentTypes.parse_obj({
            "discord": obj.get("discord"),
            "email": obj.get("email"),
            "pushbullet": obj.get("pushbullet"),
            "pushover": obj.get("pushover"),
            "slack": obj.get("slack"),
            "telegram": obj.get("telegram"),
            "webhook": obj.get("webhook"),
            "webpush": obj.get("webpush")
        })
        return _obj


