# coding: utf-8

"""
    Overseerr API

    This is the documentation for the Overseerr API backend.  Two primary authentication methods are supported:  - **Cookie Authentication**: A valid sign-in to the `/auth/plex` or `/auth/local` will generate a valid authentication cookie. - **API Key Authentication**: Sign-in is also possible by passing an `X-Api-Key` header along with a valid API Key generated by Overseerr. 

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class ProductionCompany(BaseModel):
    """
    ProductionCompany
    """
    id: Optional[Union[StrictFloat, StrictInt]] = None
    logo_path: Optional[StrictStr] = Field(None, alias="logoPath")
    name: Optional[StrictStr] = None
    origin_country: Optional[StrictStr] = Field(None, alias="originCountry")
    __properties = ["id", "logoPath", "name", "originCountry"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ProductionCompany:
        """Create an instance of ProductionCompany from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if logo_path (nullable) is None
        # and __fields_set__ contains the field
        if self.logo_path is None and "logo_path" in self.__fields_set__:
            _dict['logoPath'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ProductionCompany:
        """Create an instance of ProductionCompany from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ProductionCompany.parse_obj(obj)

        _obj = ProductionCompany.parse_obj({
            "id": obj.get("id"),
            "logo_path": obj.get("logoPath"),
            "name": obj.get("name"),
            "origin_country": obj.get("originCountry")
        })
        return _obj


