# coding: utf-8

"""
    Overseerr API

    This is the documentation for the Overseerr API backend.  Two primary authentication methods are supported:  - **Cookie Authentication**: A valid sign-in to the `/auth/plex` or `/auth/local` will generate a valid authentication cookie. - **API Key Authentication**: Sign-in is also possible by passing an `X-Api-Key` header along with a valid API Key generated by Overseerr. 

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr

class RadarrSettings(BaseModel):
    """
    RadarrSettings
    """
    active_directory: StrictStr = Field(..., alias="activeDirectory")
    active_profile_id: Union[StrictFloat, StrictInt] = Field(..., alias="activeProfileId")
    active_profile_name: StrictStr = Field(..., alias="activeProfileName")
    api_key: StrictStr = Field(..., alias="apiKey")
    base_url: Optional[StrictStr] = Field(None, alias="baseUrl")
    external_url: Optional[StrictStr] = Field(None, alias="externalUrl")
    hostname: StrictStr = Field(...)
    id: Optional[Union[StrictFloat, StrictInt]] = None
    is4k: StrictBool = Field(...)
    is_default: StrictBool = Field(..., alias="isDefault")
    minimum_availability: StrictStr = Field(..., alias="minimumAvailability")
    name: StrictStr = Field(...)
    port: Union[StrictFloat, StrictInt] = Field(...)
    prevent_search: Optional[StrictBool] = Field(None, alias="preventSearch")
    sync_enabled: Optional[StrictBool] = Field(None, alias="syncEnabled")
    use_ssl: StrictBool = Field(..., alias="useSsl")
    __properties = ["activeDirectory", "activeProfileId", "activeProfileName", "apiKey", "baseUrl", "externalUrl", "hostname", "id", "is4k", "isDefault", "minimumAvailability", "name", "port", "preventSearch", "syncEnabled", "useSsl"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> RadarrSettings:
        """Create an instance of RadarrSettings from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                            "id",
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> RadarrSettings:
        """Create an instance of RadarrSettings from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return RadarrSettings.parse_obj(obj)

        _obj = RadarrSettings.parse_obj({
            "active_directory": obj.get("activeDirectory"),
            "active_profile_id": obj.get("activeProfileId"),
            "active_profile_name": obj.get("activeProfileName"),
            "api_key": obj.get("apiKey"),
            "base_url": obj.get("baseUrl"),
            "external_url": obj.get("externalUrl"),
            "hostname": obj.get("hostname"),
            "id": obj.get("id"),
            "is4k": obj.get("is4k"),
            "is_default": obj.get("isDefault"),
            "minimum_availability": obj.get("minimumAvailability"),
            "name": obj.get("name"),
            "port": obj.get("port"),
            "prevent_search": obj.get("preventSearch"),
            "sync_enabled": obj.get("syncEnabled"),
            "use_ssl": obj.get("useSsl")
        })
        return _obj


