# coding: utf-8

"""
    Overseerr API

    This is the documentation for the Overseerr API backend.  Two primary authentication methods are supported:  - **Cookie Authentication**: A valid sign-in to the `/auth/plex` or `/auth/local` will generate a valid authentication cookie. - **API Key Authentication**: Sign-in is also possible by passing an `X-Api-Key` header along with a valid API Key generated by Overseerr. 

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr, conlist
from overseerr_api.models.episode import Episode

class Season(BaseModel):
    """
    Season
    """
    air_date: Optional[StrictStr] = Field(None, alias="airDate")
    episode_count: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="episodeCount")
    episodes: Optional[conlist(Episode)] = None
    id: Optional[Union[StrictFloat, StrictInt]] = None
    name: Optional[StrictStr] = None
    overview: Optional[StrictStr] = None
    poster_path: Optional[StrictStr] = Field(None, alias="posterPath")
    season_number: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="seasonNumber")
    __properties = ["airDate", "episodeCount", "episodes", "id", "name", "overview", "posterPath", "seasonNumber"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Season:
        """Create an instance of Season from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in episodes (list)
        _items = []
        if self.episodes:
            for _item in self.episodes:
                if _item:
                    _items.append(_item.to_dict())
            _dict['episodes'] = _items
        # set to None if air_date (nullable) is None
        # and __fields_set__ contains the field
        if self.air_date is None and "air_date" in self.__fields_set__:
            _dict['airDate'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Season:
        """Create an instance of Season from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Season.parse_obj(obj)

        _obj = Season.parse_obj({
            "air_date": obj.get("airDate"),
            "episode_count": obj.get("episodeCount"),
            "episodes": [Episode.from_dict(_item) for _item in obj.get("episodes")] if obj.get("episodes") is not None else None,
            "id": obj.get("id"),
            "name": obj.get("name"),
            "overview": obj.get("overview"),
            "poster_path": obj.get("posterPath"),
            "season_number": obj.get("seasonNumber")
        })
        return _obj


