# coding: utf-8

"""
    Overseerr API

    This is the documentation for the Overseerr API backend.  Two primary authentication methods are supported:  - **Cookie Authentication**: A valid sign-in to the `/auth/plex` or `/auth/local` will generate a valid authentication cookie. - **API Key Authentication**: Sign-in is also possible by passing an `X-Api-Key` header along with a valid API Key generated by Overseerr. 

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, conlist
from overseerr_api.models.plex_library import PlexLibrary

class SettingsPlexSyncGet200Response(BaseModel):
    """
    SettingsPlexSyncGet200Response
    """
    current_library: Optional[PlexLibrary] = Field(None, alias="currentLibrary")
    libraries: Optional[conlist(PlexLibrary)] = None
    progress: Optional[Union[StrictFloat, StrictInt]] = None
    running: Optional[StrictBool] = None
    total: Optional[Union[StrictFloat, StrictInt]] = None
    __properties = ["currentLibrary", "libraries", "progress", "running", "total"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SettingsPlexSyncGet200Response:
        """Create an instance of SettingsPlexSyncGet200Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of current_library
        if self.current_library:
            _dict['currentLibrary'] = self.current_library.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in libraries (list)
        _items = []
        if self.libraries:
            for _item in self.libraries:
                if _item:
                    _items.append(_item.to_dict())
            _dict['libraries'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SettingsPlexSyncGet200Response:
        """Create an instance of SettingsPlexSyncGet200Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SettingsPlexSyncGet200Response.parse_obj(obj)

        _obj = SettingsPlexSyncGet200Response.parse_obj({
            "current_library": PlexLibrary.from_dict(obj.get("currentLibrary")) if obj.get("currentLibrary") is not None else None,
            "libraries": [PlexLibrary.from_dict(_item) for _item in obj.get("libraries")] if obj.get("libraries") is not None else None,
            "progress": obj.get("progress"),
            "running": obj.get("running"),
            "total": obj.get("total")
        })
        return _obj


