# coding: utf-8

"""
    Overseerr API

    This is the documentation for the Overseerr API backend.  Two primary authentication methods are supported:  - **Cookie Authentication**: A valid sign-in to the `/auth/plex` or `/auth/local` will generate a valid authentication cookie. - **API Key Authentication**: Sign-in is also possible by passing an `X-Api-Key` header along with a valid API Key generated by Overseerr. 

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool

class SonarrSeriesAddOptionsInner(BaseModel):
    """
    SonarrSeriesAddOptionsInner
    """
    ignore_episodes_with_files: Optional[StrictBool] = Field(None, alias="ignoreEpisodesWithFiles")
    ignore_episodes_without_files: Optional[StrictBool] = Field(None, alias="ignoreEpisodesWithoutFiles")
    search_for_missing_episodes: Optional[StrictBool] = Field(None, alias="searchForMissingEpisodes")
    __properties = ["ignoreEpisodesWithFiles", "ignoreEpisodesWithoutFiles", "searchForMissingEpisodes"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SonarrSeriesAddOptionsInner:
        """Create an instance of SonarrSeriesAddOptionsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if ignore_episodes_with_files (nullable) is None
        # and __fields_set__ contains the field
        if self.ignore_episodes_with_files is None and "ignore_episodes_with_files" in self.__fields_set__:
            _dict['ignoreEpisodesWithFiles'] = None

        # set to None if ignore_episodes_without_files (nullable) is None
        # and __fields_set__ contains the field
        if self.ignore_episodes_without_files is None and "ignore_episodes_without_files" in self.__fields_set__:
            _dict['ignoreEpisodesWithoutFiles'] = None

        # set to None if search_for_missing_episodes (nullable) is None
        # and __fields_set__ contains the field
        if self.search_for_missing_episodes is None and "search_for_missing_episodes" in self.__fields_set__:
            _dict['searchForMissingEpisodes'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SonarrSeriesAddOptionsInner:
        """Create an instance of SonarrSeriesAddOptionsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return SonarrSeriesAddOptionsInner.parse_obj(obj)

        _obj = SonarrSeriesAddOptionsInner.parse_obj({
            "ignore_episodes_with_files": obj.get("ignoreEpisodesWithFiles"),
            "ignore_episodes_without_files": obj.get("ignoreEpisodesWithoutFiles"),
            "search_for_missing_episodes": obj.get("searchForMissingEpisodes")
        })
        return _obj


