# coding: utf-8

"""
    Overseerr API

    This is the documentation for the Overseerr API backend.  Two primary authentication methods are supported:  - **Cookie Authentication**: A valid sign-in to the `/auth/plex` or `/auth/local` will generate a valid authentication cookie. - **API Key Authentication**: Sign-in is also possible by passing an `X-Api-Key` header along with a valid API Key generated by Overseerr. 

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr

class TautulliSettings(BaseModel):
    """
    TautulliSettings
    """
    api_key: Optional[StrictStr] = Field(None, alias="apiKey")
    external_url: Optional[StrictStr] = Field(None, alias="externalUrl")
    hostname: Optional[StrictStr] = None
    port: Optional[Union[StrictFloat, StrictInt]] = None
    use_ssl: Optional[StrictBool] = Field(None, alias="useSsl")
    __properties = ["apiKey", "externalUrl", "hostname", "port", "useSsl"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TautulliSettings:
        """Create an instance of TautulliSettings from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if api_key (nullable) is None
        # and __fields_set__ contains the field
        if self.api_key is None and "api_key" in self.__fields_set__:
            _dict['apiKey'] = None

        # set to None if external_url (nullable) is None
        # and __fields_set__ contains the field
        if self.external_url is None and "external_url" in self.__fields_set__:
            _dict['externalUrl'] = None

        # set to None if hostname (nullable) is None
        # and __fields_set__ contains the field
        if self.hostname is None and "hostname" in self.__fields_set__:
            _dict['hostname'] = None

        # set to None if port (nullable) is None
        # and __fields_set__ contains the field
        if self.port is None and "port" in self.__fields_set__:
            _dict['port'] = None

        # set to None if use_ssl (nullable) is None
        # and __fields_set__ contains the field
        if self.use_ssl is None and "use_ssl" in self.__fields_set__:
            _dict['useSsl'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TautulliSettings:
        """Create an instance of TautulliSettings from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return TautulliSettings.parse_obj(obj)

        _obj = TautulliSettings.parse_obj({
            "api_key": obj.get("apiKey"),
            "external_url": obj.get("externalUrl"),
            "hostname": obj.get("hostname"),
            "port": obj.get("port"),
            "use_ssl": obj.get("useSsl")
        })
        return _obj


