# coding: utf-8

"""
    Overseerr API

    This is the documentation for the Overseerr API backend.  Two primary authentication methods are supported:  - **Cookie Authentication**: A valid sign-in to the `/auth/plex` or `/auth/local` will generate a valid authentication cookie. - **API Key Authentication**: Sign-in is also possible by passing an `X-Api-Key` header along with a valid API Key generated by Overseerr. 

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from overseerr_api.models.notification_agent_types import NotificationAgentTypes

class UserSettingsNotifications(BaseModel):
    """
    UserSettingsNotifications
    """
    discord_enabled: Optional[StrictBool] = Field(None, alias="discordEnabled")
    discord_enabled_types: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="discordEnabledTypes")
    discord_id: Optional[StrictStr] = Field(None, alias="discordId")
    email_enabled: Optional[StrictBool] = Field(None, alias="emailEnabled")
    notification_types: Optional[NotificationAgentTypes] = Field(None, alias="notificationTypes")
    pgp_key: Optional[StrictStr] = Field(None, alias="pgpKey")
    pushbullet_access_token: Optional[StrictStr] = Field(None, alias="pushbulletAccessToken")
    pushover_application_token: Optional[StrictStr] = Field(None, alias="pushoverApplicationToken")
    pushover_sound: Optional[StrictStr] = Field(None, alias="pushoverSound")
    pushover_user_key: Optional[StrictStr] = Field(None, alias="pushoverUserKey")
    telegram_bot_username: Optional[StrictStr] = Field(None, alias="telegramBotUsername")
    telegram_chat_id: Optional[StrictStr] = Field(None, alias="telegramChatId")
    telegram_enabled: Optional[StrictBool] = Field(None, alias="telegramEnabled")
    telegram_send_silently: Optional[StrictBool] = Field(None, alias="telegramSendSilently")
    __properties = ["discordEnabled", "discordEnabledTypes", "discordId", "emailEnabled", "notificationTypes", "pgpKey", "pushbulletAccessToken", "pushoverApplicationToken", "pushoverSound", "pushoverUserKey", "telegramBotUsername", "telegramChatId", "telegramEnabled", "telegramSendSilently"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> UserSettingsNotifications:
        """Create an instance of UserSettingsNotifications from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of notification_types
        if self.notification_types:
            _dict['notificationTypes'] = self.notification_types.to_dict()
        # set to None if discord_enabled_types (nullable) is None
        # and __fields_set__ contains the field
        if self.discord_enabled_types is None and "discord_enabled_types" in self.__fields_set__:
            _dict['discordEnabledTypes'] = None

        # set to None if discord_id (nullable) is None
        # and __fields_set__ contains the field
        if self.discord_id is None and "discord_id" in self.__fields_set__:
            _dict['discordId'] = None

        # set to None if pgp_key (nullable) is None
        # and __fields_set__ contains the field
        if self.pgp_key is None and "pgp_key" in self.__fields_set__:
            _dict['pgpKey'] = None

        # set to None if pushbullet_access_token (nullable) is None
        # and __fields_set__ contains the field
        if self.pushbullet_access_token is None and "pushbullet_access_token" in self.__fields_set__:
            _dict['pushbulletAccessToken'] = None

        # set to None if pushover_application_token (nullable) is None
        # and __fields_set__ contains the field
        if self.pushover_application_token is None and "pushover_application_token" in self.__fields_set__:
            _dict['pushoverApplicationToken'] = None

        # set to None if pushover_sound (nullable) is None
        # and __fields_set__ contains the field
        if self.pushover_sound is None and "pushover_sound" in self.__fields_set__:
            _dict['pushoverSound'] = None

        # set to None if pushover_user_key (nullable) is None
        # and __fields_set__ contains the field
        if self.pushover_user_key is None and "pushover_user_key" in self.__fields_set__:
            _dict['pushoverUserKey'] = None

        # set to None if telegram_bot_username (nullable) is None
        # and __fields_set__ contains the field
        if self.telegram_bot_username is None and "telegram_bot_username" in self.__fields_set__:
            _dict['telegramBotUsername'] = None

        # set to None if telegram_chat_id (nullable) is None
        # and __fields_set__ contains the field
        if self.telegram_chat_id is None and "telegram_chat_id" in self.__fields_set__:
            _dict['telegramChatId'] = None

        # set to None if telegram_send_silently (nullable) is None
        # and __fields_set__ contains the field
        if self.telegram_send_silently is None and "telegram_send_silently" in self.__fields_set__:
            _dict['telegramSendSilently'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> UserSettingsNotifications:
        """Create an instance of UserSettingsNotifications from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return UserSettingsNotifications.parse_obj(obj)

        _obj = UserSettingsNotifications.parse_obj({
            "discord_enabled": obj.get("discordEnabled"),
            "discord_enabled_types": obj.get("discordEnabledTypes"),
            "discord_id": obj.get("discordId"),
            "email_enabled": obj.get("emailEnabled"),
            "notification_types": NotificationAgentTypes.from_dict(obj.get("notificationTypes")) if obj.get("notificationTypes") is not None else None,
            "pgp_key": obj.get("pgpKey"),
            "pushbullet_access_token": obj.get("pushbulletAccessToken"),
            "pushover_application_token": obj.get("pushoverApplicationToken"),
            "pushover_sound": obj.get("pushoverSound"),
            "pushover_user_key": obj.get("pushoverUserKey"),
            "telegram_bot_username": obj.get("telegramBotUsername"),
            "telegram_chat_id": obj.get("telegramChatId"),
            "telegram_enabled": obj.get("telegramEnabled"),
            "telegram_send_silently": obj.get("telegramSendSilently")
        })
        return _obj


